unit MainFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ActnList, Clipbrd;

type
  TMainForm = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    HandleEdit: TEdit;
    ClassEdit: TEdit;
    TextEdit: TEdit;
    OnTopCheckBox: TCheckBox;
    Timer: TTimer;
    ActionList: TActionList;
    CopyAction: TAction;
    procedure FormCreate(Sender: TObject);
    procedure TimerTimer(Sender: TObject);
    procedure OnTopCheckBoxClick(Sender: TObject);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure CopyActionExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.DFM}

{ Misc Routines }

procedure SetStayOnTop(Form: TForm; Value: Boolean);
const
  Flag: array[Boolean] of Cardinal = (HWND_NOTOPMOST, HWND_TOPMOST);
begin
  SetWindowPos(Form.Handle, Flag[Value], 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE);
end;

{ TMainForm }

procedure TMainForm.FormCreate(Sender: TObject);
var
  R: TRect;
begin
  R := Screen.WorkAreaRect;
  Left := R.Right - Width;
  Top := R.Bottom - Height;
  SetStayOnTop(Self, True);
end;

procedure TMainForm.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
  if NewHeight <> Height then
    Resize := False;
end;

procedure TMainForm.TimerTimer(Sender: TObject);
var
  Pos: TPoint;
  Handle: HWND;
  Buf: array[0..1024] of Char;
begin
  GetCursorPos(Pos);
  Handle := WindowFromPoint(Pos);
  HandleEdit.Text := IntToStr(Handle);
  GetClassName(Handle, Buf, 1024);
  ClassEdit.Text := Buf;
  SendMessage(Handle, WM_GETTEXT, 1024, Integer(@Buf));
  TextEdit.Text := Buf;
end;

procedure TMainForm.OnTopCheckBoxClick(Sender: TObject);
begin
  SetStayOnTop(Self, OnTopCheckBox.Checked);
end;

procedure TMainForm.CopyActionExecute(Sender: TObject);
begin
  Clipboard.AsText :=
    Format('Handle: %s', [HandleEdit.Text]) + #13#10 +
    Format('Class: %s', [ClassEdit.Text]) + #13#10 +
    Format('Text: %s', [TextEdit.Text]);
end;

end.
